<?php
	require "devvjdb.php";
	require "devglobalVariables.php";
?>

<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
<title>Vinyl Junkies Catalogue Admin - Results of your catalogue search:</title>

<script language="javascript" src="jsrsClient.js"></script>
<script language="javascript">

// These are the application functions
function doSavePiece(currId_pk) {

	var currPiece = pieceHash.getById_pk(currId_pk);
	
	// Update the piece Object to reflect the new values
	formatObj = document.getElementById("piece_z_format_fk_" + currId_pk);
	formatDesc = formatObj.options[formatObj.selectedIndex].value;
	currPiece.z_format_fk = findByDesc(z_formatHash, formatDesc);
	
	// 2 fields to populate for country for legacy
	countryObj = document.getElementById("piece_z_country_fk_" + currId_pk);
	countryDesc = countryObj.options[countryObj.selectedIndex].value;
	currPiece.z_country_fk = findByDesc(z_countryHash, countryDesc);
	currPiece.country_tx = countryDesc;	
	
	currPiece.vjcatno_tx = document.getElementById("piece_vjcatno_tx_" + currId_pk).value;
	currPiece.artist_tx = document.getElementById("piece_artist_tx_" + currId_pk).value;
	currPiece.title_tx = document.getElementById("piece_title_tx_" + currId_pk).value;
	currPiece.label_tx = document.getElementById("piece_label_tx_" + currId_pk).value;
	currPiece.catno_tx = document.getElementById("piece_catno_tx_" + currId_pk).value;
	currPiece.year_nr = document.getElementById("piece_year_nr_" + currId_pk).value;
	currPiece.category_tx = document.getElementById("piece_category_tx_" + currId_pk).value;

	audioValue = document.getElementById("piece_audio_bl_" + currId_pk).checked;	
	if (audioValue == true) {
		currPiece.audio_bl = 1;
	} else {
		currPiece.audio_bl = 0;
	}
	
	currPiece.price_nr = document.getElementById("piece_price_nr_" + currId_pk).value;

	newValue = document.getElementById("piece_new_bl_" + currId_pk).checked;
	if (newValue == true) {
		currPiece.new_bl = 1;
	} else {
		currPiece.new_bl = 0;
	}

	vjchoiceValue = document.getElementById("piece_vjchoice_bl_" + currId_pk).checked;
	if (vjchoiceValue == true) {
		currPiece.vjchoice_bl = 1;
	} else {
		currPiece.vjchoice_bl = 0;
	}

	imgValue = document.getElementById("piece_img_bl_" + currId_pk).checked;
	if (imgValue == true) {
		currPiece.img_bl = 1;
	} else {
		currPiece.img_bl = 0;
	}

	tracklistValue = document.getElementById("piece_tracklist_bl_" + currId_pk).checked;
	if (tracklistValue == true) {
		currPiece.tracklist_bl = 1;
	} else {
		currPiece.tracklist_bl = 0;
	}

	activeValue = document.getElementById("piece_active_bl_" + currId_pk).checked;
	if (activeValue == true) {
		currPiece.active_bl = 1;
	} else {
		currPiece.active_bl = 0;
	}

	persistPiece(currPiece);

	trackRow = document.getElementById("track_row_" + currId_pk);

	if (trackRow) {
		doUpdateTrackObjs(currId_pk);
	}

	persistTracks(currPiece);
}

function doSaveAll() {

	for (i = 0; i < pieceHash.length(); i++) {
		doSavePiece(pieceHash.id_pk);
	}
}

function doUpdateTrackObjs(currId_pk) {
	
	 currPiece = pieceHash.getById_pk(currId_pk);
	 currTrackHash = currPiece.getTracks();
	 for (i = 0; i < currTrackHash.length(); i++) {
	 	 currTrack = currTrackHash.getByIndex(i);
		 currTrackId_pk = currTrack.id_pk;
        	 currTrack.vjsubcatno_tx = currPiece.vjcatno_tx + "_" + document.getElementById("track_vjsubcatno_tx_" + currTrackId_pk).value;
	         currTrack.title_tx = document.getElementById("track_title_tx_" + currTrackId_pk).value;
        	 currTrack.artist_tx = document.getElementById("track_artist_tx_" + currTrackId_pk).value;
                                                                                                                                                               
	         audioValue = document.getElementById("track_audio_bl_" + currTrackId_pk).checked;
        	 if (audioValue == true) {
			currTrack.audio_bl = 1;
	         } else {
        	        currTrack.audio_bl = 0;
	         }
        	 currTrack.side_tx = document.getElementById("track_side_tx_" + currTrackId_pk).value;
	}
}

function doCreateTrack(currId_pk) {
	
	currPiece = pieceHash.getById_pk(currId_pk);

        audioValue = document.getElementById("track_audio_bl_new_" + currId_pk).checked;
        if (audioValue == true) {
    		audioBit = 1;
	} else {
		audioBit = 0;
	}
	
	newTrack = new trackObj("new",
			     currId_pk,
			     currPiece.vjcatno_tx + "_" + (currPiece.numberOfTracks() + 1),
			     document.getElementById("track_title_tx_new_" + currId_pk).value,
			     document.getElementById("track_artist_tx_new_" + currId_pk).value,
			     audioBit,
			     document.getElementById("track_side_tx_new_" + currId_pk).value);

	doCloseTracks(currId_pk);
	
	currPiece.addTrack(newTrack);
	
	doShowTracks(currId_pk);
}

function doBulkChange(fld) {

	if (fld == "price_nr") {
		for (i = 0; i < pieceHash.length(); i++) {
			currPiece = pieceHash.getByIndex(i);
			currId_pk = currPiece.id_pk;
			document.getElementById("piece_price_nr_" + currId_pk).value = document.getElementById("piece_price_nr_bulk").value;
		}
		
	} else {
		for (i = 0; i < pieceHash.length(); i++) {
			currPiece = pieceHash.getByIndex(i);
			currId_pk = currPiece.id_pk;
			document.getElementById("piece_" + fld + "_" + currId_pk).checked = document.getElementById("piece_" + fld + "_bulk").checked;
		}
	}
}

function doShowTracks(currId_pk) {

	currPiece = pieceHash.getById_pk(currId_pk);
	pieceTable = document.getElementById("piece_table_" + currId_pk);
	rows = pieceTable.rows;
	trackRow = pieceTable.insertRow(rows.length);
	trackRow.id = "track_row_" + currId_pk;
	tracksHash = currPiece.getTracks();
	
	// Prepare a table for insertion
	htmlString = "<table id=\"track_table_" + currId_pk + "\" border=\"2\"><tbody>";

	// With a header row
	htmlString += "<tr bgcolor=\"#FF9900\">";
	htmlString += "<td align=\"center\" colspan=\"2\">VJ Track No</td>";
	htmlString += "<td align=\"center\">Artist</td>";
	htmlString += "<td align=\"center\">Title</td>";
	htmlString += "<td align=\"center\">Side</td>";
	htmlString += "<td align=\"center\">Audio</td>";
	htmlString += "</tr>";

	// And a Row for adding new tracks
	htmlString += "<tr>";
	htmlString += "<td><button id=\"newTrackButton_" + currId_pk + "\" type=\"button\" value=\"NewTrack\" onclick=\"doCreateTrack(" + currId_pk + ")\">Insert</button></td>";
	htmlString += createLabelCell(currPiece.vjcatno_tx + "_" + (tracksHash.length() + 1));
	htmlString += createTextField("track_artist_tx_new_" + currId_pk, 20, 1, "");
	htmlString += createTextField("track_title_tx_new_" + currId_pk, 20, 1, "");
	htmlString += createTextField("track_side_tx_new_" + currId_pk, 18, 1, "");
	htmlString += createChb("track_audio_bl_new_" + currId_pk, "");
	htmlString += "</tr>";
	
	htmlString += "<tr><td colspan=\"6\">&nbsp;</td></tr>";

	for (i = 0; i < tracksHash.length(); i++) {
		currTrack = tracksHash.getByIndex(i);
		trackId_pk = currTrack.id_pk;
		htmlString += "<tr>";

		htmlString += createLabelCell(currTrack.vjsubcatno_tx.substring(0, currTrack.vjsubcatno_tx.indexOf("_") + 1));
		htmlString += createTextField("track_vjsubcatno_tx_" + trackId_pk, 5, 1, currTrack.vjsubcatno_tx.substring(currTrack.vjsubcatno_tx.indexOf("_") + 1));
		htmlString += createTextField("track_artist_tx_" + trackId_pk, 20, 1, currTrack.artist_tx);
		htmlString += createTextField("track_title_tx_" + trackId_pk, 20, 1, currTrack.title_tx);
		htmlString += createTextField("track_side_tx_" + trackId_pk, 18, 1, currTrack.side_tx);
		htmlString += createChb("track_audio_bl_" + trackId_pk, currTrack.audio_bl);

		htmlString += "</tr>";
	}	
	htmlString += "</table>";

	trackRow.innerHTML = htmlString;

	tracksButtonCell = document.getElementById("tracksButtonCell_" + currId_pk);
	tracksButtonCell.innerHTML = "<button id=\"tracksButton_" + currId_pk + "\" value=\"CloseTracks\" type=\"button\" onclick=\"doCloseTracks(" + currId_pk + ")\">Close Tracks</button>";

}

function doCloseTracks(currId_pk) {

	// update the track object before closing
	doUpdateTrackObjs(currId_pk);

	// Then close the row
	trackRow = document.getElementById("track_row_" + currId_pk);
	trackRow.parentNode.removeChild(trackRow);

	tracksButtonCell = document.getElementById("tracksButtonCell_" + currId_pk);
        tracksButtonCell.innerHTML = "<button id=\"tracksButton_" + currId_pk + "\" value=\"Tracks\" type=\"button\" onclick=\"doShowTracks(" + currId_pk + ")\">Tracks</button>";
}	

function doShowNotes(currId_pk) {

	currPiece = pieceHash.getById_pk(currId_pk);
        pieceTable = document.getElementById("piece_table_" + currId_pk);
        rows = pieceTable.rows;
        notesRow = pieceTable.insertRow(rows.length);
        notesRow.id = "notes_row_" + currId_pk;

	notesRow.innerHTML = "<td align=\"center\"><textarea rows=\"4\" cols=\"70\" id=\"piece_notes_tx_" + currId_pk + "\"></textarea></td>";

	notesButtonCell = document.getElementById("notesButtonCell_" + currId_pk);
	notesButtonCell.innerHTML = "<button id=\"notesButton_" + currId_pk + "\" value=\"Notes\" type=\"button\" onclick=\"doCloseNotes(" + currId_pk + ")\">Close Notes</button>";

}

function doCloseNotes(currId_pk) {

	notesRow = document.getElementById("notes_row_" + currId_pk);
	notesRow.parentNode.removeChild(notesRow);

	 notesButtonCell = document.getElementById("notesButtonCell_" + currId_pk);
         notesButtonCell.innerHTML = "<button id=\"notesButton_" + currId_pk + "\" value=\"Notes\" type=\"button\" onclick=\"doShowNotes(" + currId_pk + ")\">Notes</button>";

}

function doRemovePiece(currId_pk) {

	pieceTable = document.getElementById("piece_table_" + currId_pk);
	pieceTable.parentNode.removeChild(pieceTable);

	pieceHash.removeById_pk(currId_pk);

}

function findByDesc(zHash, desc_tx) {

/*
	This function finds the id_pk of 
	a particular entry in the z_list 
	from its desc_tx
*/

	for (var i = 0 ; i < zHash.length() ; i++) {
		currObj = zHash.getByIndex(i);
		if (currObj.desc_tx == desc_tx) {
			return currObj.id_pk;
		}
	}

	return "null";
}
	

// The functions for persisting to db
function persistPiece(piece) {
	jsrsPOST = 1;
	alert("about to do persist piece");
	jsrsExecute("dbHandler.php", donePersistPiece, "persistPiece", piece.toArray(), true);
}

function donePersistPiece(returnString) {
	alert("The callback is " + returnString);
//	alert("PersisPiece Callback");
}

function persistTracks(piece) {

	currTracksHash = piece.getTracks();

	for (i = 0; i < currTracksHash.length(); i++) {
		currTrack = currTracksHash.getByIndex(i);
		jsrsPOST = 1;
		jsrsExecute("dbHandler.php", donePersistTrack, "persistTrack", currTrack.toArray(), true);
	}
}

function donePersistTrack(returnString) {
	alert("The callback is " + returnString);
//	alert("Persist Track Callback");
}

function hash() {

/* 
	This data structure will be used to give provide the behaviour 
	of a hash table for any of our collections of objects.  They
	can be looked up by id_pk (hash[id_pk] = object) but we can 
	still iterate over the entire collection using the iterator 
	(iterator[index] = id_pk)
*/

	this.hash = new Array();
	this.iterator = new Array();

	this.add = function(newItem) {
		this.hash[newItem.id_pk] = newItem;
		this.iterator.push(newItem.id_pk);
	};

	this.getById_pk = function(id_pk) {
		return this.hash[id_pk];
	};

	this.getByIndex = function(i) {
		return this.hash[this.iterator[i]];
	};

	this.length = function() {
		return this.iterator.length;
	};

	this.removeById_pk = function(id_pk) {
		// chop out the item from both arrays
		this.newHash = new Array();
		this.newIterator = new Array();
		j = 0;
		for (i = 0; i < this.iterator.length; i++) {
			currItem = this.hash[this.iterator[i]];
			if (currItem.id_pk != id_pk) {
				this.newHash[currItem.id_pk] = currItem;
				this.newIterator.push(currItem.id_pk);
			}
		}
		this.hash = this.newHash;
		this.iterator = this.newIterator;
	};

}
		
function pieceObj(id_pk, z_format_fk, z_country_fk, vjcatno_tx, artist_tx, title_tx, label_tx, catno_tx, year_nr, category_tx, audio_bl, country_tx, price_nr, new_bl, vjchoice_bl, img_bl, tracklist_bl, active_bl, notes_tx) {

/* 
	This object represents the db object Piece.  Most DB fields
	are expressed, the left out fields are either not relavent to 
	the web admin - TIMESTAMP_DT - or are not used, the rest of the
	left out ones.  The database will be cleaned of these fields
	during redevelopment.

*/

	this.id_pk = id_pk;
	this.z_format_fk = z_format_fk;
	this.z_country_fk = z_country_fk;
	this.vjcatno_tx = vjcatno_tx;
	this.artist_tx = artist_tx;
	this.title_tx = title_tx;
	this.label_tx = label_tx;
	this.catno_tx = catno_tx;
	this.year_nr = year_nr;
	this.category_tx = category_tx;
	this.audio_bl = audio_bl;
	this.country_tx = country_tx; 
	this.price_nr = price_nr;
	this.new_bl = new_bl;
	this.vjchoice_bl = vjchoice_bl;
	this.img_bl = img_bl;
	this.tracklist_bl = tracklist_bl;
	this.active_bl = active_bl;
	this.notes_tx = notes_tx;

	this.toArray = function () {
		return (new Array(
			this.id_pk,
			this.z_format_fk,
			this.z_country_fk,
		        this.vjcatno_tx,
		        this.artist_tx,
		        this.title_tx,
		        this.label_tx,
		        this.catno_tx,
		        this.year_nr,
		        this.category_tx,
		        this.audio_bl,
		        this.country_tx,
		        this.price_nr,
			this.new_bl,
			this.vjchoice_bl,
			this.img_bl,
			this.tracklist_bl,
			this.active_bl,
			this.notes_tx));
	};

	var tracks = new hash();

	this.addTrack = function(newTrack) {
		tracks.add(newTrack);
	};

	this.getTracks = function() {
		return tracks;
	};

	this.hasTracks = function() {
		if (tracks.length() > 0) { return true; }
		else { return false; }
	};

	this.numberOfTracks = function() {
		return tracks.length();
	};
}


function trackObj(id_pk, piece_fk, vjsubcatno_tx, title_tx, artist_tx, audio_bl, side_tx) {

/*
	This object represents a Track, and expressed all 
	track DB fields except ARTIST_ALIAS_FK which is not 
	used.

*/

	this.id_pk = id_pk;
	this.piece_fk = id_pk;
	this.vjsubcatno_tx = vjsubcatno_tx;
	this.title_tx = title_tx;
	this.artist_tx = artist_tx;
	this.audio_bl = audio_bl;
	this.side_tx = side_tx;

	this.toArray = function() {
		return (new Array(this.id_pk,
				  this.piece_fk,
				  this.vjsubcatno_tx,
				  this.title_tx,
				  this.artist_tx,
				  this.audio_bl,
				  this.side_tx));
	};

}

function z_listObj(id_pk, desc_tx) {
	
/* 
	we can use the same base object for all z_lists
*/
	
	this.id_pk = id_pk;
	this.desc_tx = desc_tx;
}

// Create the Hashs to store objects

var z_formatHash = new hash();
var z_countryHash = new hash();
var pieceHash = new hash();

<?php
        while($pieceLine = mysql_fetch_array($pieceResult, MYSQL_ASSOC))
        {
		$id_pk = $pieceLine['ID_PK'];
?>

var currPiece = new pieceObj(
		"<?php echo htmlspecialchars(stripslashes($id_pk)); ?>",
		"<?php echo htmlspecialchars(stripslashes($pieceLine['Z_FORMAT_FK'])); ?>",
		"<?php echo htmlspecialchars(stripslashes($pieceLine['Z_COUNTRY_FK'])); ?>",
		"<?php echo htmlspecialchars(stripslashes($pieceLine['VJCATNO_TX'])); ?>",
		"<?php echo htmlspecialchars(stripslashes($pieceLine['ARTIST_TX'])); ?>",
		"<?php echo htmlspecialchars(stripslashes($pieceLine['TITLE_TX'])); ?>",
		"<?php echo htmlspecialchars(stripslashes($pieceLine['LABEL_TX'])); ?>",
		"<?php echo htmlspecialchars(stripslashes($pieceLine['CATNO_TX'])); ?>",
		"<?php echo htmlspecialchars(stripslashes($pieceLine['YEAR_NR'])); ?>",
		"<?php echo htmlspecialchars(stripslashes($pieceLine['CATEGORY_TX'])); ?>",
		"<?php echo htmlspecialchars(stripslashes($pieceLine['AUDIO_BL'])); ?>",
		"<?php echo htmlspecialchars(stripslashes($pieceLine['COUNTRY_TX'])); ?>",
		"<?php echo htmlspecialchars(stripslashes($pieceLine['PRICE_NR'])); ?>",
		"<?php echo htmlspecialchars(stripslashes($pieceLine['NEW_BL'])); ?>",
		"<?php echo htmlspecialchars(stripslashes($pieceLine['VJCHOICE_BL'])); ?>",
		"<?php echo htmlspecialchars(stripslashes($pieceLine['IMG_BL'])); ?>",
		"<?php echo htmlspecialchars(stripslashes($pieceLine['TRACKLIST_BL'])); ?>",
		"<?php echo htmlspecialchars(stripslashes($pieceLine['ACTIVE_BL'])); ?>",
		"<?php echo htmlspecialchars(stripslashes($pieceLine['NOTES_TX'])); ?>"
		);

<?php
		$trackQuery = "SELECT T.ID_PK, T.PIECE_FK, T.VJSUBCATNO_TX, T.TITLE_TX, T.ARTIST_TX, T.AUDIO_BL, T.SIDE_TX
				FROM track T WHERE T.PIECE_FK = $id_pk";

		$trackResult = mysql_query($trackQuery) or die("Query failed : " . mysql_error());

		while($trackLine = mysql_fetch_array($trackResult, MYSQL_ASSOC))
		{
?>
			var currTrack = new trackObj(
				"<?php echo htmlspecialchars(stripslashes($trackLine['ID_PK'])); ?>",
				"<?php echo htmlspecialchars(stripslashes($trackLine['PIECE_FK'])); ?>",
				"<?php echo htmlspecialchars(stripslashes($trackLine['VJSUBCATNO_TX'])); ?>",
				"<?php echo htmlspecialchars(stripslashes($trackLine['TITLE_TX'])); ?>",
				"<?php echo htmlspecialchars(stripslashes($trackLine['ARTIST_TX'])); ?>",
				"<?php echo htmlspecialchars(stripslashes($trackLine['AUDIO_TX'])); ?>",
				"<?php echo htmlspecialchars(stripslashes($trackLine['SIDE_TX'])); ?>"
			);

			// Now add that track to the piece record
			currPiece.addTrack(currTrack);			
<?php
		// Close the track loop
		}
?>
		// Then add the currPiece to the pieceHash, using the id_pk as the key
		pieceHash.add(currPiece);
<?php
	// Close the piece loop
	}

	// Now prepare the arrays of z lists
	$formatQuery = "SELECT F.ID_PK, F.DESC_TX FROM z_format F";

	$formatResult = mysql_query($formatQuery) or die("Query failed : " . mysql_error());
	while($formatLine = mysql_fetch_array($formatResult, MYSQL_ASSOC))
	{
?>
		var currZ_format = new z_listObj("<?php echo htmlspecialchars(stripslashes($formatLine['ID_PK'])); ?>", "<?php echo htmlspecialchars(stripslashes($formatLine['DESC_TX'])); ?>");
		z_formatHash.add(currZ_format);
<?php
	// Close the format loop
	}

	$countryQuery = "SELECT C.ID_PK, C.DESC_TX FROM z_country C";
        $countryResult = mysql_query($countryQuery) or die("Query failed : " . mysql_error());
	while($countryLine = mysql_fetch_array($countryResult, MYSQL_ASSOC))
	{
?>
		var currZ_country = new z_listObj("<?php echo htmlspecialchars(stripslashes($countryLine['ID_PK'])); ?>", "<?php echo htmlspecialchars(stripslashes($countryLine['DESC_TX'])); ?>");
		z_countryHash.add(currZ_country);
<?php
        // Close the country loop
	}

	mysql_close($link);
?>

function buildTable() {

// TABLE 1 START - Table for ALL pieces

	var htmlString = "<table width=\"680\"><tbody>";

	htmlString += "<tr><td>";

// TABLE 1A START - The Bulk Change fields

	htmlString += "<p>These fields will update all pieces on the page.  Pieces can be removed from the list with the \"Remove\" button.<br>";  

	htmlString += "<table id=\"bulk_table\" border=\"4\" bordercolor=\"#000000\" cellpadding=\"2\"><tbody>";
	htmlString += "<tr>";

	htmlString += createLabelCell("Price :");
	htmlString += createTextField("piece_price_nr_bulk", 30, 1, "");
	htmlString += "<td><button id=\"bulkPriceButton\" value=\"BulkPrice\" type=\"button\" onclick=\"doBulkChange('price_nr')\">Update</button></td>";

	htmlString += "</tr><tr>";

	htmlString += createLabelCell("Active :");
	htmlString += createChb("piece_active_bl_bulk", "0");
	htmlString += "<td><button id=\"bulkActiveButton\" value=\"BulkActive\" type=\"button\" onclick=\"doBulkChange('active_bl')\">Update</button></td>";
	
	htmlString += "</tr><tr>";

	htmlString += createLabelCell("New :");
	htmlString += createChb("piece_new_bl_bulk", "0");
	htmlString += "<td><button id=\"bulkNewButton\" value=\"BulkNew\" type=\"button\" onclick=\"doBulkChange('new_bl')\">Update</button></td>";

	htmlString += "</tr><tr>";

	htmlString += createLabelCell("VJChoice :");
	htmlString += createChb("piece_vjchoice_bl_bulk", "0");
	htmlString += "<td><button id=\"bulkVJChoiceButton\" value=\"BulkVJChoice\" type=\"button\" onclick=\"doBulkChange('vjchoice_bl')\">Update</button></td>";

	htmlString += "</tr><tr>";

	htmlString += "<td colspan=\"3\" align=\"center\"><button id=\"saveAllButton\" value=\"SaveAll\" type=\"button\" onclick=\"doSaveAll()\">Save All</button></td>";
	
	htmlString += "</tr></table>";
	
	htmlString += "</td></tr>";

	htmlString += "<tr><td>&nbsp;</td></tr>";
	htmlString += "<tr><td>Each piece can be edited individually.</td></tr>";

	//Iterate over the piece array
	for(var i = 0; i < pieceHash.length(); i++) {
		var currPiece = pieceHash.getByIndex(i); 
		var currId_pk = currPiece.id_pk;

		// A new row and cell for each piece
		htmlString += "<tr><td>";	

// TABLE 2 START - Table for EACH piece

		// A visible table for each piece
		htmlString += "<table id=\"piece_table_" + currId_pk + "\" border=\"4\" bordercolor=\"#000000\" cellpadding=\"2\">";

		// A row and cell for the button panel
		htmlString += "<tr><td align=\"center\">";

// TABLE 3 START - The Button Panel

		// Prepare the button panel
		htmlString += "<table><tbody><tr>";
		htmlString += "<td id=\"saveButtonCell_" + currId_pk + "\" align=\"center\"><button id=\"saveButton_" + currId_pk + "\" value=\"Save\" type=\"button\" onclick=\"doSavePiece(" + currId_pk + ")\">Save</button></td>";
		htmlString += "<td id=\"notesButtonCell_" + currId_pk + "\" align=\"center\"><button id=\"showNotesButton_" + currId_pk + "\" value=\"Notes\" type=\"button\" onclick=\"doShowNotes(" + currId_pk + ")\">Notes</button></td>";
		htmlString += "<td id=\"tracksButtonCell_" + currId_pk + "\" align=\"center\"><button id=\"showTracksButton_" + currId_pk + "\" value=\"Tracks\" type=\"button\" onclick=\"doShowTracks(" + currId_pk + ")\">Tracks</button></td>";
		htmlString += "<td id=\"removeButtonCell_" + currId_pk + "\" align=\"center\"><button id=\"removeButton_" + currId_pk + "\" value=\"Remove\" type=\"button\" onclick=\"doRemovePiece(" + currId_pk + ")\">Remove</button></td>";
		htmlString += "</td></tr></table>";

// TABLE 3 END - The Button Panel

		// Close the button panel cell and the row 
		htmlString += "</td></tr>";
		
		// Now a table row for the detail fields 
		htmlString += "<tr><td>";

// TABLE 4 START - The Text Fields

		// Now the details table 
		htmlString += "<table id=\"details_table_" + currId_pk + "\"><tbody><tr>";
		
		// Create a label field pair for each attribute and add to the row

		// Double row for Vj Num and Cat Num
		htmlString += createLabelCell("Vj Num:");
		htmlString += createTextField("piece_vjcatno_tx_" + currId_pk, 30, 1, currPiece.vjcatno_tx);

		htmlString += createLabelCell("Cat Num:");
		htmlString += createTextField("piece_catno_tx_" + currId_pk, 30, 1, currPiece.catno_tx);


		// Single Row for Artist
		htmlString += "</tr><tr>";

		htmlString += createLabelCell("Artist :");
		htmlString += createTextField("piece_artist_tx_" + currId_pk, 70, 3, currPiece.artist_tx);

		// Single Row for Title
		htmlString += "</tr><tr>";

		htmlString += createLabelCell("Title :");
		htmlString += createTextField("piece_title_tx_" + currId_pk, 70, 3, currPiece.title_tx);

		// Single Row for Label
		htmlString += "</tr><tr>";

		htmlString += createLabelCell("Label :");
		htmlString += createTextField("piece_label_tx_" + currId_pk, 70, 3, currPiece.label_tx);

		// Single Row for Category
		htmlString += "</tr><tr>";

		htmlString += createLabelCell("Category :");
		htmlString += createTextField("piece_category_tx_" + currId_pk, 70, 3, currPiece.category_tx);

		// Double row for Format and Country
		//label_cell = document.createElement("TD");
		
		// Double row for Year and Price
		htmlString += "</tr><tr>";

		htmlString += createLabelCell("Year :");
		htmlString += createTextField("piece_year_nr_" + currId_pk, 30, 1, currPiece.year_nr);

		htmlString += createLabelCell("Price :");
		htmlString += createTextField("piece_price_nr_" + currId_pk, 30, 1, currPiece.price_nr);

		// Double row for z_country and z_format
		htmlString += "</tr><tr>";

		htmlString += createLabelCell("Format :");
		htmlString += createDDField("piece_z_format_fk_" + currId_pk, z_formatHash, currPiece.z_format_fk); 

		htmlString += createLabelCell("Country :");
		htmlString += createDDField("piece_z_country_fk_" + currId_pk, z_countryHash, currPiece.z_country_fk);

		// Now finish off the details table 
		htmlString += "</tr></table>";

// TABLE 4 END - The Text Fields

		// And its cell
		htmlString += "</td></tr>";

		// Prepare a cell for the  panel
		htmlString += "<tr><td align=\"center\">"

// TABLE 5 START - The Checkboxes

		// Now add the radio button panel
		htmlString += "<table><tbody><tr>";

		htmlString += createLabelCell("Active:");
		htmlString += createChb("piece_active_bl_" + currId_pk, currPiece.active_bl);
		
		htmlString += createLabelCell("TrackList:");
		htmlString += createChb("piece_tracklist_bl_" + currId_pk, currPiece.tracklist_bl);
		
		htmlString += createLabelCell("Image:");
		htmlString += createChb("piece_img_bl_" + currId_pk, currPiece.img_bl);
		
		htmlString += createLabelCell("New:");
		htmlString += createChb("piece_new_bl_" + currId_pk, currPiece.new_bl);
		
		htmlString += createLabelCell("VJ Choice:");
		htmlString += createChb("piece_vjchoice_bl_" + currId_pk, currPiece.vjchoice_bl);
		
		htmlString += createLabelCell("Audio:");
		htmlString += createChb("piece_audio_bl_" + currId_pk, currPiece.audio_bl);

		// Close the checkbox table
		htmlString += "</tr></table>";

// TABLE 5 END - The Checkboxes

		// Close the checkbox cell and row
		htmlString += "</td></tr>";

		// Close the piece Table
		htmlString += "</table>";

// TABLE 2 END - One for EACH piece

		htmlString += "</td></tr><tr><td>&nbsp;</td></tr>";

	}

	// Finish off overall table
	htmlString += "</table>";

// TABLE 1 END - Table for ALL pieces 

	document.getElementById("tablediv").innerHTML = htmlString;
}

/*

function addTracksTable(id_pk) {

	var currPiece = pieceHash.getById_pk(id_pk);
	var currTracksArray = currPiece.getTracks;

	returnString = "<table border=\"4\" bordercolor=\"#000000\" cellpadding=\"2\"><tbody>";

	// add table header
	returnString += "<tr><td>VJ Sub Cat #</td><td>Title</td><td>Aritst</td><td>Date</td><td>Audio</td></tr>";

	for (var i = 0; i < currTracksArray.length; i++) {
		var currTrack = currTracksArray.getByIndex(i);
		returnString += "<tr>";
		returnString += "<td align=\"center\">" + currTrack.vjsubcatno_tx + "</td>";
		returnString += "<td align=\"right\"><input id=\"track_
		
*/
function createLabelCell(labelValue) {
	return "<td align=\"right\">" + labelValue + "</td>";
}

function createTextField(fldId, fldSize, fldSpan, fldValue) {
	return "<td align=\"left\" colspan=\"" + fldSpan + "\"><input id=\"" + fldId + "\" type=\"text\" size=\"" + fldSize + "\" value=\"" + fldValue + "\"></td>";
}

function createDDField(fldId, dataHash, currFk) {
	
	var returnString = "<td align=\"left\"><select id=\"" + fldId + "\">";
	
	for(var i = 0; i < dataHash.length(); i++) {
		currData = dataHash.getByIndex(i);
		if (currData.id_pk == currFk) {
			returnString += "<option selected>" + currData.desc_tx + "</option>";
		} else {
			returnString += "<option>" + currData.desc_tx + "</option>";
		}
	}

	returnString += "</select></td>";
	return returnString;
}

function createChb(fldId, isChecked) {

	var returnString = "<td align=\"center\">";

	if (isChecked == 1) returnString = "<input id=\"" + fldId + "\" type=\"checkbox\" checked><td>";
	else returnString = "<input id=\"" + fldId + "\" type=\"checkbox\"></td>";

	return returnString;
}

function makeChbCell(row, chb_name, chb_state) {
	cell = document.createElement("TD");
	cell.setAttribute("bgcolor", "#CCCCC");
	cell.setAttribute("align","center");
	
	/*chb = document.createElement("INPUT");
	chb.setAttribute("type", "checkbox");
	chb.setAttribute("name", "chb_name");
	if (chb_state == 1) chb.setAttribute("checked", "checked");*/

	if (chb_state == 1) {
		cell.appendChild(document.createTextNode("X"));
	} else {
		cell.appendChild(document.createTextNode('\u00A0'));
	}

	row.appendChild(cell);

}

function makeAudioCell(row, vjcatno) {
	image = document.createElement("IMG");
	image.setAttribute("src", "<?php echo $GLOBALS['SECURE_IMG_URL']; ?>/audio.gif");

	link = document.createElement("A");
	link.setAttribute("href", "samples/" + vjcatno + ".ram");
	
	link.appendChild(image);
	
	cell = document.createElement("TD");
	cell.setAttribute("bgcolor", "#CCCCC");
	cell.setAttribute("align","center");
	
	cell.appendChild(link);

	row.appendChild(cell);
}


</script>

</head>
<body background="<?php echo $GLOBALS['SECURE_IMG_URL']; ?>/chartbackground.gif" link="#ffffff" vlink="#ffffff">
<p><big><big><strong><font face="Arial">&nbsp; Catalogue Admin Search Results:</font></strong></big></big></p>
<font face="Arial" size="2">
<p><font size="2" color="#000000" face="Arial, Helvetica, sans-serif"><b><a href="consoleselect.php">Return to Admin Console Menu</a></b></font></p>
<p><font size="2" color="#000000" face="Arial, Helvetica, sans-serif"><b><a href="catalogueadminmain.php">Return to Search Page</a></b></font></p>

<div id="tablediv">

</div>

<script language="javascript">
	window.onload = buildTable();
</script>

<p><font size="2" color="#000000" face="Arial, Helvetica, sans-serif">
<b><a href="consoleselect.php">Return to Admin Console Menu</a></b></font></p>
<p><font size="2" color="#000000" face="Arial, Helvetica, sans-serif">
<b><a href="catalogueadminmain.php">Return to Search Page</a></b></font></p>
</body>
</html>
